/*
  Final project - BabySEATer
  All the information is described in details in our instructable.

  The circuit:
  * Described in details in step 7 in our instructable.
 
  Video link: https://youtu.be/Npogkf-Exv8
 
  Created By:
  Neta Greenwald
  Tal Efrat
*/

//States:
#define STATE_START 10
#define STATE_BABY_IN_THE_CAR 20
#define STATE_DRIVING 30
#define STATE_PARENT_LEFT_THE_CAR 40
#define STATE_ALERT_BABY_FORGOTTEN 50  

//Notes:
#define NOTE_Do  262
#define NOTE_Re  294
#define NOTE_Mi  330
#define NOTE_Fa  349
#define NOTE_Sol 392
#define NOTE_La  440
#define NOTE_Se  494
#define NOTE_G4  392
#define NOTE_C5  523
#define NOTE_E5  659
#define NOTE_G5  784
#define NOTE_B5  988
#define NOTE_A5  880
#define NOTE_GS5 831
#define NOTE_AS5 932

//Duration of notes:
#define WHOLE         2200       // Length of time in milliseconds of a whole note (i.e. a full bar).
#define HALF          WHOLE/2
#define QUARTER       HALF/2
#define EIGHTH        QUARTER/2
#define EIGHTH_TRIPLE QUARTER/3
#define SIXTEENTH     EIGHTH/2

//Baby-shark song:
#define NUM_OF_TIMES_PLAYING_SONG  3
#define RED 0
#define GREEN 1
#define BLUE 2
#define num_of_leds_in_cpx 10
#define num_of_values_in_RGB 3

//Thresholds:
#define MAX_TEMPERATURE_THRESHOLD 27
#define MIN_TEMPERATURE_THRESHOLD 21
#define CAPACITANCE_THRESHOLD 1000
#define IR_THRESHOLD 70

//Blynk:
#define BLYNK_PRINT SerialUSB
#define BLYNK_DEBUG SerialUSB
#define EspSerial Serial1
#define ESP8266_BAUD 9600

//Includes:
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

ESP8266 wifi(&EspSerial);

//Speaker:
const uint8_t spTEMPERATURE[]   PROGMEM = {0x0E,0xF8,0x2E,0x2C,0x00,0xCB,0x8F,0x8F,0xA8,0x59,0x15,0xF7,0x58,0x79,0xD2,0x9A,0x5D,0x22,0xB5,0xF5,0x4D,0x47,0x96,0xAB,0x5A,0x87,0x69,0x0E,0x85,0xF7,0x46,0x1D,0xA1,0x0C,0x10,0xE0,0x32,0xBB,0x04,0x56,0x5E,0x62,0x91,0xA6,0x79,0xEF,0x7D,0xEC,0xC1,0x00,0x63,0x6C,0x46,0xC0,0x03,0x16,0x18,0x7D,0x8F,0x29,0x68,0x96,0xB5,0x4D,0x25,0x27,0x71,0x85,0xF7,0xBE,0xF6,0xBD,0x9F,0xF5,0x09,0x77,0x59,0xC2,0xDE,0x9A,0x27,0xBE,0xFE,0xFD,0x7F};
const uint8_t spHIGH[]          PROGMEM = {0x04,0xC8,0x7E,0x9C,0x02,0x12,0xD0,0x80,0x06,0x56,0x96,0x7D,0x67,0x4B,0x2C,0xB9,0xC5,0x6D,0x6E,0x7D,0xEB,0xDB,0xDC,0xEE,0x8C,0x4D,0x8F,0x65,0xF1,0xE6,0xBD,0xEE,0x6D,0xEC,0xCD,0x97,0x74,0xE8,0xEA,0x79,0xCE,0xAB,0x5C,0x23,0x06,0x69,0xC4,0xA3,0x7C,0xC7,0xC7,0xBF,0xFF,0x0F};
const uint8_t spLOW[]           PROGMEM = {0x65,0xDF,0x98,0xA3,0x4A,0xB4,0xE5,0x65,0x4E,0xAB,0x9F,0xD4,0xA2,0x92,0xBC,0x9E,0xB6,0xF2,0xC8,0x71,0xEA,0x7B,0x9B,0xD5,0x24,0x5E,0x3D,0xCC,0x79,0x77,0x3B,0xFB,0xB9,0xF4,0xBD,0xEE,0xF5,0x0C,0x97,0x37,0x5D,0x0B,0x92,0xC7,0xDF,0xFE,0xFD,0x7F};
const uint8_t spLIGHT[]         PROGMEM = {0x61,0x69,0xC0,0x2B,0x82,0xB3,0xA5,0x79,0x01,0x9A,0x52,0x71,0x57,0xC7,0x31,0x0C,0x5C,0x5D,0xC1,0x59,0x6F,0x7B,0x9A,0xC6,0x3B,0xCB,0xA5,0xCB,0xA9,0xAA,0x6D,0x6B,0xB3,0xCD,0xA7,0x6C,0x29,0xB4,0x34,0x56,0xAF,0xBA,0x0F,0x23,0x93,0x5C,0x32,0xC7,0xB6,0xF6,0x46,0xA4,0x39,0xB3,0xF3,0x86,0x40,0x11,0xCA,0x5D,0x44,0x36,0x00,0x80,0x02,0x96,0x2A,0x35,0xC0,0xB6,0x97,0x0C,0xE8,0xF9,0x04,0x01,0xC5,0x19,0xFC,0x3F};

//Global variables:
int state = 10;
int capacitance_value;
bool key_in_the_switch = false;
bool timer_on = false;
long time_capacitance_signal_lost = 0;
int IR;
int light_intensity_with_window_shade = 70;
int light_intensity_without_window_shade = light_intensity_with_window_shade * 1.5; //Filter 50% screen
int current_index_in_RGB = 0;
long last_temperature_notification = 0;
long last_light_notification = 0;
long last_alert = 0;

char auth[] = "vs53XUrIE7Xpw6V92A0HO6N8bsKOk5i8";
char ssid[] = "";
char pass[] = "";

/* Virtual pins:
 * V0 - Tasks reminder
 * V1 - Temperature - from Integromat
 * V2 - Crying baby
 * V3 - Light - from Integromat
 * V4 - ForgottenBaby - to Integromat
 * V5 - Temperature - to Integromat
 * V6 - Light - to Integromat
 */

void setup() {
  CircuitPlayground.begin();
  SerialUSB.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);
}

void loop() {
  Blynk.run();
  switch(state){
    case STATE_START:
      state = handleStart();
      break;
    case STATE_BABY_IN_THE_CAR:
      state = handleBabyInTheCar();
      break;
    case STATE_DRIVING:
      state = handleDriving();
      break;
    case STATE_PARENT_LEFT_THE_CAR:
      state = checkIfParentForgotTheBaby();
      break;
    case STATE_ALERT_BABY_FORGOTTEN:
      state = alertBabyIsForgotten();
      break;
  }
}

/*
 * Sample proximity until we recognize that the baby is in the car.
 * Return : the int of the current state or the int of the next state if we recognized proximity.
 */
int handleStart(){
  int nextState;

  if(checkIfBabyIsInTheCar()){
    nextState = STATE_BABY_IN_THE_CAR;
  }
  //If not, we stay at the same state until we will recognize proximity.
  else{
    nextState = STATE_START;
  }

  return nextState;
}

/*
 * The board placed in the baby's seat.
 * If the IR we sample is bigger than the threshold we defined - it means that the baby in the car.
 * Return : true if we recognize proximity, false otherwise.
 */
bool checkIfBabyIsInTheCar() {
  delay(200);
  digitalWrite(25, HIGH);
  delay(50);
  IR = analogRead(A8);
  digitalWrite(25, LOW);
  IR = map(IR, 930, 970, 0, 100);
  Serial.println(IR);
 
  return IR > IR_THRESHOLD;
}

/*
 * Sample capacitance until we recognize that the key is in the switch (And that means that the parent is in the car).
 * Return : the int of the current state or the int of the next state if we recognized the parent is in the car.
 */
int handleBabyInTheCar() {
  //Serial.println("baby in the car");
  int nextState;

  //If the key is inserted to the switch, turn key_in_the_switch to true (initialized to false).
  checkIfDriving();
  if(key_in_the_switch == true) {
    nextState = STATE_DRIVING;
  }
  //If not, it means that the baby is in the car but the parent did not start the vehicle yet -> So we keep sampeling.
  else{
    nextState = STATE_BABY_IN_THE_CAR;
  }

  return nextState;
}

/*
 * When key is inserted to the switch -
 * the alligator will touch the metal part of the key and the capacitance value will be bigger than the thrshold.
 * At this moment we turn key_in_the_switch to true and make sure the timer is off.
 * Return : void.
 */
void checkIfDriving(){
  capacitance_value = CircuitPlayground.readCap(A1);
  delay(1);
  //Serial.println(capacitance_value);
  if(capacitance_value > CAPACITANCE_THRESHOLD){
    key_in_the_switch = true;
    timer_on = false;
  }
}

/*
 * We first get to this method when the key is in the switch.
 * We sample capacitance until we recognize that it's value is lower than the threshold.
 * If the capacitance signal is lost - We still do not know if it was because of one wrong sampeling or because the key is actually taken out of the switch -
 * so we keep staying at state driving for a minute and keep sampeling.
 * If during this minute we see that the capacitance is bigger than the threshold - we act like nothing happend.
 * If after a minute the capacitance is still lower than the threshold - we move to STATE_PARENT_LEFT_THE_CAR.
 * If the parent is still driving - We check the temperature and the light in the baby's area.
 * Return : the int of the current state or the int of the next state according to what is written above.
 */
int handleDriving() {
  //Serial.println("driving");
  int nextState;

  //We check if capacitance signal lost just when we know there is a signal at the moment.
  if(key_in_the_switch) {
    checkIfCapacitanceSignalLost();
    //If lost - It turn on the timer & turn key_in_the_switch to false so in the next iteration we will enter the 'else' and not the 'if'.
    nextState = STATE_DRIVING;
  }
  else{
    //If we reached here, we know the timer is on. Check if a minute already passed
    if(checkIfParentLeftTheCar() == true) {
      nextState = STATE_PARENT_LEFT_THE_CAR;
    }
    else {
      //If the timer is on for less than a minute - check if there is a capacitance signal
      checkIfDriving();
      nextState = STATE_DRIVING;
    }
  }

  if(nextState != STATE_PARENT_LEFT_THE_CAR) {
    checkTemperatureInTheBabysArea();
    checkLightIntensityInTheBabysArea();
  }

  return nextState;
}

/*
 * If the capcitance value is lower than the threahold we suspect the key is taken out of the switch -
 * we start a timer in order to re-sample it in a minute.
 * Return: void.
 */
void checkIfCapacitanceSignalLost(){
   capacitance_value = CircuitPlayground.readCap(A1);

  if(capacitance_value < CAPACITANCE_THRESHOLD){
    //Serial.println(capacitance_value);
    timer_on = true;
    time_capacitance_signal_lost = millis();
    key_in_the_switch = false;
  }
}

/*
 * Check if a minute already passed since the capacitance signal lost.
 * Return : true if a minute passed, false otherwise.
 */
bool checkIfParentLeftTheCar(){
  bool parentLeftTheCar = false;
  unsigned long minute = 60000;
 
  if(timer_on == true) {
    //If we reached here - we know we suspected the key was taken out of the switch.
    if((millis() - time_capacitance_signal_lost) > minute) {
      //If we arrived here it means that the driver took the keys from the switch for sure.
      parentLeftTheCar = true;
      timer_on = false;
    }
  }
 
  return parentLeftTheCar;
}

/*
 * Samples the temperature and when recognizing it is not in the normal range -
 * a warning will be said out loud and a notification will be sent to the parent's phone.
 * Return: void.
 */
void checkTemperatureInTheBabysArea() {
  float currentTemperature = CircuitPlayground.temperature();

  if(currentTemperature > MAX_TEMPERATURE_THRESHOLD) {
    notifyTemperature(currentTemperature, "high");
  }

  if(currentTemperature < MIN_TEMPERATURE_THRESHOLD) {
    notifyTemperature(currentTemperature, "low");
  }
}

/*
 * We want that it will notify only one time per incident - so after we recognized exception in the temperature values,
 * we check if 15 minutes passed since the last exception. If yes, we notify. Otherwise, we do nothing.
 * Return: void.
 */
void notifyTemperature(float currentTemperature, String highOrLow) {
  long frequency = 15;
 
  if(checkIfTimePassed(last_temperature_notification, frequency)) {
     Blynk.virtualWrite(V0, highOrLow, currentTemperature);
     last_temperature_notification = millis();
  }
}

/*
 * Param: the last time we notify about an exception, the frequency of notifications (in minutes).
 * The method checks if frequencyInMinutes passed since the last notification.
 * Return : true if frequencyInMinutes passed since the last notification OR if there was no notification yet. False otherwise.
 */
bool checkIfTimePassed(long last_notification, long frequencyInMinutes) {
  bool timePassed = false;
  unsigned long minute = 60000;
 
  if((millis() - last_notification) > (minute*frequencyInMinutes)) {
    timePassed = true;
  }

  if(last_notification == 0) {
    if(millis() < (minute*frequencyInMinutes)) {
      timePassed = true;
    }
  }

  return timePassed;
}

 /*
 * Samples the light and when recognizing it is over the threshold -
 * a warning will be said out loud and a notification will be sent to the parent's phone.
 * Return: void.
 */
void checkLightIntensityInTheBabysArea() {
  float currentLightIntensity = CircuitPlayground.lightSensor();
  long frequency = 15;

  if(checkIfTimePassed(last_light_notification, frequency)) {
    if(currentLightIntensity  >= light_intensity_without_window_shade) {
      Blynk.virtualWrite(V2,0);
      last_light_notification = millis();
    }
  }
}

/*
 * Check if the baby is still in the car, five minutes after the capacitance signal lost.
 * Return :
 * The int of the current state if five minutes didn't pass yet.
 * OR
 * The int of STATE_ALERT_BABY_FORGOTTEN if 5 minutes passed and the baby is still in the car.
 * OR
 * The int of STATE_START if 5 minutes passed and the baby is not in the car anymore.
 */
int checkIfParentForgotTheBaby(){
  //Serial.println("parent left");
  int nextState;
  unsigned long minute = 60000;

  if((millis() - time_capacitance_signal_lost) > (minute * 5)) {
    if(checkIfBabyIsInTheCar()){
      nextState = STATE_ALERT_BABY_FORGOTTEN;
    }
    else{
      nextState = STATE_START;
    }
  }
  else{
    nextState = STATE_PARENT_LEFT_THE_CAR;
  }
 
  return nextState;
}

/*
 * Checks if the baby is still in the car and if yes-
 * sends a notification to the parent's phone if one minute passed since the last notification.
 * Return : the int of the current state or the int of STATE_START if the baby is not in the car anymore.
 */
int alertBabyIsForgotten() {
  float currentTemperature = CircuitPlayground.temperature();
  int nextState;
  long frequency = 1;
 
  if(checkIfBabyIsInTheCar()) {
    if(checkIfTimePassed(last_alert, frequency)) {
       Blynk.virtualWrite(V4, currentTemperature);
       last_alert = millis();
    }
   
    nextState = STATE_ALERT_BABY_FORGOTTEN;
  }
  else {
    nextState = STATE_START;
  }
 
  return nextState;
}

/*
 * Triggered when the SmartTask App notify on a reminder related to the baby
 * Plays a notification sound
 */
BLYNK_WRITE(V0) {
  if(state == STATE_DRIVING){
    int pinValue = param.asInt();
    //Serial.println(pinValue);
    notificationSound();
  }
}

/*
 * Triggered after we recognized the temperature is out of the normal range.
 * Notify about it out loud.
 */
BLYNK_WRITE(V1) {
  String highOrLow = param.asString();
 
  if(highOrLow.equals("high")){
    CircuitPlayground.speaker.say(spHIGH);
  }
 
  if(highOrLow.equals("low")){
    CircuitPlayground.speaker.say(spLOW);
  }
 
  CircuitPlayground.speaker.say(spTEMPERATURE);
  CircuitPlayground.speaker.end();
}

/*
 * Play the baby shark song for defined number of times.
 */
BLYNK_WRITE(V2) {
  if(state == STATE_DRIVING){
    int pinValue = param.asInt();
    //Serial.println(pinValue);
    for (int i = 0; i < NUM_OF_TIMES_PLAYING_SONG; ++i) {
      babySharkSong();
    }
  }
}

/*
 * Triggered after we recognized the light is bigger than the threshold.
 * Notify about it out loud.
 */
BLYNK_WRITE(V3) {
  CircuitPlayground.speaker.say(spLIGHT);
  CircuitPlayground.speaker.end();
}

/*
 * Play "Baby Shark" song, turn on the leds and change their colors.
 */
void babySharkSong() {
  for(int i = 0; i < 3; i++) { //"Baby Shark" song repeats this sequence of notes 3 times.
    oneBeatInAudiovisualSong(NOTE_Do, EIGHTH_TRIPLE, 1);
    oneBeatInAudiovisualSong(NOTE_Re, EIGHTH_TRIPLE, 1);
    oneBeatInAudiovisualSong(NOTE_Fa, EIGHTH_TRIPLE, 3);
    oneBeatInAudiovisualSong(NOTE_Fa, SIXTEENTH, 4);
  }

  oneBeatInAudiovisualSong(NOTE_Fa, SIXTEENTH,2);
  oneBeatInAudiovisualSong(NOTE_Mi, EIGHTH_TRIPLE, 1);

  setLedsColor(0, 0, 0); //Turn off the light at the end of the song
}

/*
 * Playing one beat of the song, each time with different led color.
 */
void oneBeatInAudiovisualSong(int note, int duration, int numOfTimesTheSameNotePlayedConsecutively) {
  for(int i = 0; i < numOfTimesTheSameNotePlayedConsecutively; i++) {
    CircuitPlayground.playTone(note, duration);
    if(current_index_in_RGB == RED) {
      setLedsColor(255,0,0);
    }

    if(current_index_in_RGB == GREEN) {
      setLedsColor(0,255,0);
    }

    if(current_index_in_RGB == BLUE) {
      setLedsColor(0,0,255);
    }

    current_index_in_RGB = (current_index_in_RGB + 1) % num_of_values_in_RGB;
    Serial.println(current_index_in_RGB);
  }
}

/*
 * Set all the leds to a requested color.
 * Return: void
 */
void setLedsColor(int red, int green, int blue){
  for(int i=0; i < num_of_leds_in_cpx; i++)
  {
    CircuitPlayground.setPixelColor(i, red, green, blue);
  }
}

/*
 * Play a notification sound.
 * Return: void.
 */
void notificationSound() {
  CircuitPlayground.playTone(NOTE_G4, EIGHTH_TRIPLE);
  CircuitPlayground.playTone(NOTE_C5, EIGHTH_TRIPLE);
  CircuitPlayground.playTone(NOTE_E5, EIGHTH_TRIPLE);
  CircuitPlayground.playTone(NOTE_G5, EIGHTH);
  CircuitPlayground.playTone(NOTE_E5, SIXTEENTH);
  CircuitPlayground.playTone(NOTE_G5, HALF);
}
